<?php

namespace Drupal\beehotel_pricealterator;
use Drupal\Core\Session\AccountInterface;

/**
 * Class Alter
 * @package Drupal\beehotel_pricealterator\Services
 */
class Alter {

  protected $currentUser;

  /**
   * PriceAlteratorBaseTable constructor.
   * @param AccountInterface $currentUser
   */
  public function __construct(AccountInterface $currentUser) {
    $this->currentUser = $currentUser;
  }


  public function ScanAlteratorsForPrice($data)  {

    $tempstore = \Drupal::service('tempstore.private')->get('beehotel_pricealterator');

    // 1. Get content

    // 1a. Base Table with base price
    $basetable = \Drupal::service('beehotel_pricealterator.prealter')->BaseTable();
    //$season    = \Drupal::service('beehotel_pricealterator.prealter')->Season();


    // 1b. Normalise data
    $data = $this->Normalise($data);
    // 1c. Validate data
    $data = $this->Validate($data);

    //dump ("Function");
    //dump (__METHOD__);
    // exit;
    //dump ($data);  exit;

    // 1d. Available Alterators see......
    $pricealterator = \Drupal::service('plugin.manager.beehotel.pricealterator');
    $alterators = $pricealterator->SortedAlterators();
    // 1e. Enabled Alterators
    $alterators = $this->CheckStatus($alterators);

    $tempstore->set('beehotel_pricealterator_log', $alterators);

    /** 2. Loop per night
    * Drupal Commerce calls Resolver once per order item (not once per night)
    * We loop nights here, providing an average price to be multiplied by items (nights)
    * @TODO: keep track of evety night price into \$data
    */
    for ($n = 0; $n < $data['nights_as_integer']; $n++) {

      $data['tmp'] = NULL;
      $data['tmp']['night_timestamp'] = $data['checkin_timestamp'] + (24*3600 * $n);
      $data['tmp']['night_date'] = date('Y-m-d', $data['tmp']['night_timestamp']);

      //dump ("wereqw2QQQ2333333333wrwer");
      //dump ($alterators);
      //exit;

      foreach ($alterators as $a) {

        $alterator = new $a['class']([],[],[],[]);

        // 3. get price for every night
        $data = $alterator->alter($data, $basetable);


        ///dump ($a->get("id")->value);
        //dump ("----------FROM ALTERATORS----------------");
        //dump ("alterator: ".$a['id']);
        //dump ($data['entity']->get('sku')->value);
        //dump ($data);
        //dump ($data['tmp']['price']);


        if (isset($data['tmp']['price'])) {
          //dump ($data['entity']->get('sku')->value);
          $price[$data['id_room']][] = $data['tmp']['price'];
        }
      }

    }


    // 4. calculate average price

    if (isset($price)) {

      //@TODO: perice array items shoud be increasing in steps, as more alterators are evaluated.
      // this is not happening. Discover why.

      //dump ($price);

      //exit;


       //$price = array_filter($price);
       //dump ("array price");
       //dump ($price[$data['id_room']]);

      //if(count($price)) {
        //$average = array_sum($price)/count($price);
      //}



      // 5. return average price into the data array
      $data['amount'][$data['id_room']] = end($price[$data['id_room']] );
      return $data;
      //dump ($average);

      //exit;

    }
    else {
      die ("Err:dsjeot5brny");
    }
    //store the average as price per item (night)
    //$price[] = $data['tmp']['price'];
    //$data['amount'][$data['id_room']] = $average;
    return ;//$data;

  }


  private function CheckStatus($alterators)  {

    $a = [];

    // @TODO: move this into yml config
    $legenda = [
      0 => "disabled",
      1 => "enabled",
      2 => "work in progress",
    ];


    foreach ($alterators as $item)  {
      if ($item['status']  == 1 )
       $a[] = $item;
    }

    return $a;

  }


  private function Validate($data)  {

    if ( isset($data['adults'])  &&    $data['adults'] < 1 && $data['adults'] > 3  )  {
      // @TODO improve this check
      die ("ERR 34wfr: check occupancy");
    }


    if (!isset($data['checkin']) || !isset($data['checkout']) )  {
      // @TODO improve this check
      die ("ERR 34weqqwfr: check in/out are mandatory");
    }


    return $data;

  }


  private function Normalise($data) {

    $data['checkin_timestamp'] = strtotime($data['checkin']);
    $data['checkout_timestamp'] = strtotime($data['checkout']);
    $data['nights'] = ($data['checkout_timestamp'] -  $data['checkin_timestamp'])/86400 ; //1 day = 86400
    $data['nights_as_integer'] = number_format($data['nights']);
    $data['checkin_timestamp'] = strtotime($data['checkin']);
    $data['day_of_the_week'] = date("N", $data['checkin_timestamp']); // 0 = Monday
    $tmp = $data['entity']->get('sku')->value;
    $data['id_room'] = strtoupper($tmp[0].$tmp[1]);
    //     dump (__METHOD__);
    //     dump ($data);
    //     exit;

    return $data;

  }


  // How to send this output to the debug block?
  public function BeeHotelLog($data, $context) {

    //@TODO -  improve the price alterator log output
    return 0;

    $BEEHOTEL_DEBUG = 1;
    $tempstore = \Drupal::service('tempstore.private')->get('beehotel_pricealterator');

    if ($BEEHOTEL_DEBUG != 1) {die ("debug bloccato");}

    $log = [];

    switch ($context['action']) {
      case 'begin':
        //$log[] = "CLASS: ".$context['CLASS']."<br/>\r\n";
        //$log[] = "FUNCTION: ". $context['FUNCTION']."<br/>\r\n";
        //$log[] = "price: ". $context['data']['price']."<br/>\r\n";

        $tempstore->set('beehotel_pricealterator_price', $context['data']['price']);
        $tempstore->set('beehotel_pricealterator_function', $context['FUNCTION']);
        $tempstore->set('beehotel_pricealterator_class', $context['CLASS']);
        //  $log[] = "data: " . json_encode($data)."<br/>\r\n";
        //  check this with tail -f /var/log/apache2/error.log
        //  error_log(json_encode($log));
        break;
      case 'step':
        //$log[] = "i equals 1";
        // check this with tail -f /var/log/apache2/error.log
        //error_log(json_encode($log));
        break;
      case 'end':

        //  $log[] = "CLASS: ".$context['CLASS']."<br/>\r\n";
        //  $log[] = "FUNCTION: ". $context['FUNCTION']."<br/>\r\n";
        //  $log[] = "price: ". $context['data']['price']."<br/>\r\n";

        $tempstore->set('beehotel_pricealterator_price', $context['data']['price']);
        $tempstore->set('beehotel_pricealterator_function', $context['FUNCTION']);
        $tempstore->set('beehotel_pricealterator_class', $context['CLASS']);

        //  $log[] = "<<";
        //  check this with tail -f /var/log/apache2/error.log
        break;
      default:
          //  $log[] = "define an action please";
          //  check this with tail -f /var/log/apache2/error.log
          //  error_log(json_encode($log));
          break;
          ;
      return;
    }
  }
}
