<?php

namespace Drupal\beehotel_pricealterator;

use Drupal\Core\Session\AccountInterface;

/**
 * Class PriceAlteratorBaseTable.
 *
 * @package Drupal\beehotel_pricealterator\Services
 *   this is part of the beehotel package
 */
class PreAlter {

  /**
   * The current user.
   *
   * @var \Drupal\Core\Session\AccountInterface
   */
  protected $currentUser;

  /**
   * A construct method for the PreAlter class.
   *
   * @param \Drupal\Core\Session\AccountInterface $currentUser
   *   Current user.
   */
  public function __construct(AccountInterface $currentUser) {
    $this->currentUser = $currentUser;
  }

  /**
   * Price base table.
   *
   * @return array
   *   get the price base table.
   */
  public function BaseTable() {

    $module_handler = \Drupal::moduleHandler();

    // Get base table.
    $basetable = $module_handler->invokeAll('beehotel_pricealterator_base_table', [[]]);

    if (!isset($basetable)) {
      dump("\$basetable is required. Is at least beehotel_pricealterators_beehotel_pricealterator_base_table running");
      exit;
    }

    return $basetable;

  }

  /**
   * Get the season of the requested night.
   *
   * @return array
   *   get the season of the requested night.
   */
  public function Season() {

    $module_handler = \Drupal::moduleHandler();

    // Get season.
    $season = $module_handler->invokeAll('beehotel_pricealterator_season', [[]]);

    if (!isset($season)) {
      dump("\$season is required. Is at least beehotel_pricealterators_beehotel_pricealterator_season running?");
      exit;
    }

    return reset($season);
  }

}
