<?php

namespace Drupal\beehotel_pricealterator;
use Drupal\Component\Plugin\PluginBase;


/**
 * A very first class to get price from base table.
 *
 *
 * We intentionally declare our base class as abstract, and don't implement the
 * order() method required by \Drupal\beehotel_pricealterator\PriceAlteratorInterface.
 * This way even if they are using our base class, developers will always be
 * required to define an order() method for their custom sandwich type.
 *
 * @see \Drupal\beehotel_pricealterator\Annotation\PriceAlterator
 * @see \Drupal\beehotel_pricealterator\PriceAlteratorInterface
 */
abstract class PriceAlteratorBase extends PluginBase implements PriceAlteratorInterface {

  /**
   * {@inheritdoc}
   */
  public function description() {
    // Retrieve the @description property from the annotation and return it.
    return $this->pluginDefinition['description'];
  }

  /**
   * {@inheritdoc}
   */
  public function calories() {
    // Retrieve the @calories property from the annotation and return it.
    return (float) $this->pluginDefinition['calories'];
  }

  /**
   * {@inheritdoc}
   */
  //abstract public function order(array $extras);

}
