<?php

namespace Drupal\beehotel_pricealterator;

use Drupal\Core\Session\AccountInterface;




/**
 * Class PriceAlteratorBaseTable
 * @package Drupal\beehotel_pricealterator\Services
 */
class PriceAlteratorBaseTable  {

  protected $currentUser;

  /**
   * PriceAlteratorBaseTable constructor.
   * @param AccountInterface $currentUser
   */
  public function __construct(AccountInterface $currentUser) {
    $this->currentUser = $currentUser;
  }


  /**
   * @return array
   */
  public function BaseTable() {

    $basetable = [];

    //  MG - MAGNOLIA
    $basetable['MR']['info']['type'] = 'room';
    $basetable['MR']['info']['type'] = 'Magnolia';
    $basetable['MR']['low'][1] = 40;  // lun - per una persona
    $basetable['MR']['low'][2] = 46;  // mar
    $basetable['MR']['low'][3] = 46;  // mer
    $basetable['MR']['low'][4] = 46;  // gio
    $basetable['MR']['low'][5] = 50;  // ven
    $basetable['MR']['low'][6] = 68;  // sab
    $basetable['MR']['low'][7] = 40;  // dom

    $basetable['MR']['high'][1]  = 68;  // lun - per una persona
    $basetable['MR']['high'][2]  = 68;  // mar
    $basetable['MR']['high'][3]  = 68;  // mer
    $basetable['MR']['high'][4]  = 68;  // gio
    $basetable['MR']['high'][5]  = 76;  // ven
    $basetable['MR']['high'][6]  = 80;  // sab
    $basetable['MR']['high'][7]  = 55;  // dom


    // MV - VENEZIA
    $basetable['VR']['info']['type'] = 'room';
    $basetable['VR']['info']['name'] = 'Venezia';
    $basetable['VR']['low'][1] = 45;  // lun - per una persona
    $basetable['VR']['low'][2] = 45;  // mar
    $basetable['VR']['low'][3] = 45;  // mer
    $basetable['VR']['low'][4] = 48;  // gio
    $basetable['VR']['low'][5] = 50;  // ven
    $basetable['VR']['low'][6] = 60;  // sab
    $basetable['VR']['low'][7] = 40;  // dom

    $basetable['VR']['high'][1]  = 68;  // lun - per una persona
    $basetable['VR']['high'][2]  = 68;  // mar
    $basetable['VR']['high'][3]  = 68; // mer
    $basetable['VR']['high'][4]  = 68;  // gio
    $basetable['VR']['high'][5]  = 74;  // ven
    $basetable['VR']['high'][6]  = 80;  // sab
    $basetable['VR']['high'][7]  = 60;  // dom
    //$basetable

    // CILIEGIO
    $basetable['CR']['type'] = 'room';
    $basetable['CR']['name'] = 'Ciliegio';
    $basetable['CR']['low'][1] = 40;  // lun - per una persona
    $basetable['CR']['low'][2] = 40;  // mar
    $basetable['CR']['low'][3] = 46;  // mer
    $basetable['CR']['low'][4] = 46;  // gio
    $basetable['CR']['low'][5] = 50;  // ven
    $basetable['CR']['low'][6] = 60;  // sab
    $basetable['CR']['low'][7] = 40;  // dom

    // ****************************
    $basetable['CR']['high'][1]  = 64;  // € lun - per una persona
    $basetable['CR']['high'][2]  = 64;  // € mar
    $basetable['CR']['high'][3]  = 64;  // € mer
    $basetable['CR']['high'][4]  = 64;  // € gio
    $basetable['CR']['high'][5]  = 64;  // € ven
    $basetable['CR']['high'][6]  = 74;  // € sab
    $basetable['CR']['high'][7]  = 60;  // € dom

    return $basetable;

  }
}
